unit canvas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls;

type
  TCanvasForm = class(TForm)
    Panel1: TPanel;
    ClearButton: TButton;
    CloseButton: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
  private
  public
    SpeedButton1 : TSpeedButton;
    X_TOP,
    Y_TOP: integer;
    MAX_X,
    MAX_Y: integer;

    Procedure Clear_Canvas;
    Procedure Set_color( R, G, B: integer );
    Procedure DrawLine( x1, y1, x2, y2: integer );
    Procedure DrawPixel( x1, y1: integer );
    Procedure DrawEllipse( x1, y1, R1, R2: integer );
  end;

var
  CanvasForm: TCanvasForm;

implementation

{$R *.DFM}

procedure TCanvasForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    SpeedButton1.Down := false;
end;

procedure TCanvasForm.FormShow(Sender: TObject);
begin
    X_TOP := 5;
    Y_TOP := 30;
    MAX_X := Width - 15;
    MAX_Y := Height - 58;
    Clear_Canvas;
end;

procedure TCanvasForm.FormPaint(Sender: TObject);
begin
    Clear_Canvas;
end;

Procedure TCanvasForm.Clear_Canvas;
var i: integer;
begin
     Canvas.Pen.Color := 0 ;
     Canvas.Brush.Color := 0 ;
     Canvas.Brush.Style := bsSolid;
     Canvas.Rectangle( X_TOP, Y_TOP, X_TOP + MAX_X, Y_TOP + MAX_Y );
end;

Procedure TCanvasForm.Set_color( R, G, B: integer );
begin
     Canvas.Pen.Color := R + (G shl 8) + (B shl 16) ;
end;

Procedure TCanvasForm.DrawLine( x1, y1, x2, y2: integer );
begin
     Canvas.MoveTo( X_TOP + x1-1, Y_TOP + y1-1 );
     Canvas.LineTo( X_TOP + x2-1, Y_TOP + Y2-1 );
end;

Procedure TCanvasForm.DrawPixel( x1, y1: integer );
begin
     Canvas.Pixels[ X_TOP + x1, Y_TOP + y1 ] := Canvas.Pen.Color;
end;

Procedure TCanvasForm.DrawEllipse( x1, y1, R1, R2: integer );
begin
     Canvas.Brush.Style := bsClear;
     Canvas.Ellipse(x1-R1, y1-R2, x1+R1, y1+R2);
end;

procedure TCanvasForm.CloseButtonClick(Sender: TObject);
begin
     Close;
end;

procedure TCanvasForm.ClearButtonClick(Sender: TObject);
begin
    Clear_Canvas;
end;

end.
